<!DOCTYPE html>
<html>
	<head>
		<title>Hamming Kodu</title>
		<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
		<meta http-equiv="X-UA-Compatible" content="IE=edge" />
		<meta name="viewport" content="width=device-width, initial-scale=1">
		<script type="text/javascript" src="jquery-1.10.2.js"></script>
		<script type="text/javascript" src="calculationlib/matrixlib.js"></script>
		<script type="text/javascript" src="calculationlib/ecclib.js"></script>
		<script type="text/javascript" src="calculationlib/polynomial.js"></script>
		<script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.6/MathJax.js?config=TeX-AMS-MML_HTMLorMML"></script>
		<!--<script type="text/javascript" src="MathJax/MathJax.js?config=TeX-AMS-MML_HTMLorMML"></script>-->
		<script type="text/x-mathjax-config">
			MathJax.Hub.Config({tex2jax: {inlineMath: [['$','$'], ['\\(','\\)']]}});
			MathJax.Localization.setLocale("tr");
		</script>
		<script>
			var AddFormula = function(container, name, tex) {
				var containerSelector = $('#' + container);
				if ($('#' + name).length == 0)
					containerSelector.append("<div id='" + name + "' style='text-align:center; visibility: visible; padding:10;'>");
				else $('#' + name).html("");

				$('#' + name).append($('<script type="math/tex">').text("\\displaystyle{"+tex+"}"));
				MathJax.Hub.Queue(["Typeset",MathJax.Hub]);
			}
		</script>
		<style>
		
		#result td {
			text-align: center;
			padding: 5px ;
			border: 1px black solid;
		}
		
		table[id=result] {
			border-collapse: collapse;
			margin-left:auto; 
			margin-right:auto;
			margin-top: 15px;
		}
		
		</style>
	
	</head>
	<body>
		<h3>Hamming Kodu</h3>

		<!--<p>Hamming kodları, lineer kodlardandır ve herhangi iki GF(q) sonlu cismi üzerinde tanımlanabilir. Bir Hamming kodu en uygun şekilde, eşlik-denetim (parity-check) matrisi ile belirtilir.</p>

		<p><b>Tanım.</b> r, pozitif bir tamsayı ve H; sütunları, (F_q)^n in sıfırdan farklı vektörleri olan bir r x (2^r-1) matris olsun. Eşlik denetim matrisi H olan koda "ikili (binary) Hamming kodu" denir ve "Ham(r,2)" ile gösterilir.</p>-->

		<table> 
		
		<tr>
		<td><b>q:</b></td>
		<td>
		<input type="text" id="txtQStart" value="2"/> 
		<input type="text" id="txtQEnd" value="7"/>
		</tr>
		</tr>
		
		<tr>
		<td><b>r:</b></td>
		<td>
		<input type="text" id="txtRStart" value="2"/>
		<input type="text" id="txtREnd" value="7"/>
		</td>
		</tr>
		
		<tr>
		<td> </td>
		<td> <input type="button" id="btnCalculate" value="Kod Boyutunu Hesapla" /> </td>
		</tr>
		
		</table>
		
		<div id="divResult"></div>
		
		<script type="text/javascript">
			$(document).ready(function () {
				$("input[type='button']").click(function (e) {
					if (e.target.id == "btnCalculate") {
						
						$("#divResult").html("");
						
						var q1 = parseInt($('#txtQStart').val());
						var q2 = parseInt($('#txtQEnd').val());
						var r1 = parseInt($('#txtRStart').val());
						var r2 = parseInt($('#txtREnd').val());
						q1 = isNaN(q1) ? q2 : q1;
						q2 = isNaN(q2) ? q1 : q2;
						r1 = isNaN(r1) ? r2 : r1;
						r2 = isNaN(r2) ? r1 : r2;
						
						var formulaText = "\\begin{eqnarray*}";
						formulaText += "n &=& \\frac{q^r-1}{q-1} \\\\";
						formulaText += "k &=& n - r";
						formulaText += "\\end{eqnarray*}";
						AddFormula("divResult", "formula", formulaText);

						var values = [];
						var qmin = Math.min(q1, q2);
						var qmax = Math.max(q1, q2);
						var rmin = Math.min(r1, r2);
						var rmax = Math.max(r1, r2);
						
						var factorial = function(a) { var v = 1; for (var i=1; i <= a; i++) v = v * i; return v; }
						var combination = function(n,k) { return factorial(n) / (factorial(n-k) * factorial(k)); }
						
						
						var col = [];
						values.push(col);
						col.push("");
						for (var r = rmin; r <= rmax; r++) {
							col.push("r=" + r);
						}
						
						for (var q = qmin; q <= qmax; q++) {
							var col = [];
							values.push(col);
							col.push("q=" + q);
							for (var r = rmin; r <= rmax; r++) {
								var n = (Math.pow(q, r) - 1) / (q - 1);
								var k = n - r;
								var text = "[" + n + "," + k + "]";
								
								//if(Math.pow(q,k) * (combination(n,0) + combination(n,1) * (q-1)) == Math.pow(q,n))
								//	text += "\\\\M";
								//else text += "\\\\MD";
								col.push(text);
							}
						}
						
						var CreateTable = function(div, name, colCount, rowCount) {
							var table = "<table id=" + name + ">";
							for (var i = 0; i < rowCount; i++) {
								table += "<tr>";
								for (var j = 0; j < colCount; j++) {
									table += "<td id=td_" + name + "_" + j + "_" + i + "> </td>";
								}
								table += "</tr>";
							}
							table += "</table>";
							$("#" + div).append(table);
						}
						
						var colCount = qmax - qmin + 2;
						var rowCount = rmax - rmin + 2;
						CreateTable("divResult", "result", colCount, rowCount);
						for (var i = 0; i < colCount; i++) {
							for (var j = 0; j < rowCount; j++){
								var cellName = "td_result_" + i + "_"+ j;
								var text = values[i][j];
								AddFormula(cellName, cellName, text);
							}
						}
						
					}
				});
			});
		</script>

	</body>
</html>
